package it.amattioli.locate;

import java.util.Collection;
import java.util.HashSet;
import java.util.Set;

import it.amattioli.dominate.Described;
import it.amattioli.dominate.EntityImpl;

public class Organization extends EntityImpl implements Described {
	private String description;
	private Set<Place> members = new HashSet<Place>(); 

	public String getDescription() {
		return description;
	}

	public void setDescription(String description) {
		this.description = description;
	}
	
	public Collection<Place> getMembers() {
		return members;
	}
	
	public boolean hasMember(Place member) {
		return members.contains(member);
	}
	
	public void addMember(Place member) {
		if (!this.hasMember(member)) {
			members.add(member);
			member.addOrganization(this);
		}
	}
}
