package it.amattioli.locate.memory;

import it.amattioli.locate.Place;

import java.io.IOException;
import java.io.InputStream;
import java.util.Map;

import javax.xml.parsers.ParserConfigurationException;
import javax.xml.parsers.SAXParser;
import javax.xml.parsers.SAXParserFactory;

import org.xml.sax.SAXException;

public class MemoryPlaceRepositoryFactory {
	private static final SAXParserFactory PARSER_FACTORY = SAXParserFactory.newInstance();
	private Map<Long, Place> repositoryContent;
	
	public void setXmlSource(String xmlResourceName) {
		SAXParser parser;
		try {
			parser = PARSER_FACTORY.newSAXParser();
		} catch (ParserConfigurationException e) {
			throw new ConfigurationException(e);
		} catch (SAXException e) {
			throw new ConfigurationException(e);
		}
		PlaceRepositoryContentBuilder builder = new PlaceRepositoryContentBuilder();
	    SaxEventsHandler seh = new SaxEventsHandler(builder);
	    InputStream input = getClass().getResourceAsStream(xmlResourceName);
	    try {
			parser.parse(input,seh);
		} catch (SAXException e) {
			throw new ConfigurationException(e);
		} catch (IOException e) {
			throw new ConfigurationException(e);
		}
	    repositoryContent = builder.getRepositoryContent();
	}
	
	public MemoryPlaceRepository getPlaceRepository() {
		return new MemoryPlaceRepository(repositoryContent);
	}
	
}
