package it.amattioli.locate.memory;

import it.amattioli.encapsulate.dates.GenericTimeInterval;

import java.io.CharArrayWriter;
import java.text.DateFormat;
import java.text.ParseException;
import java.util.Date;
import java.util.Locale;

import org.apache.commons.lang.StringUtils;
import org.xml.sax.Attributes;
import org.xml.sax.SAXException;
import org.xml.sax.helpers.DefaultHandler;

public class SaxEventsHandler extends DefaultHandler {
	private PlaceRepositoryContentBuilder builder;
	private CharArrayWriter cDataBuffer = new CharArrayWriter();
	private Locale descriptionLocale; 
	private String codeName;

	public SaxEventsHandler(PlaceRepositoryContentBuilder builder) {
		if (builder == null) {
			// TODO: GESTIRE MEGLIO L'ECCEZIONE !!!!!!!!!!!!
			throw new NullPointerException();
		}
		this.builder = builder;
	}

	public void startElement(String namespaceURI, String localName, String qName, Attributes attrs) throws SAXException {
		if (qName.equals("place")) {
			String stringId = attrs.getValue("id");
			try {
				builder.newPlace(attrs.getValue("type"), 
						         Long.parseLong(stringId));
			} catch (NumberFormatException e) {
				throw new WrongIdException(stringId);
			}
		} else if (qName.equals("code")) {
			codeName = attrs.getValue("name");
		} else if (qName.equals("description")) {
			//descriptionLocale = new Locale(attrs.getValue("locale"));
		} else if (qName.equals("zipcode")) {
			
		} else if (qName.equals("places")) {
			
		} else if (qName.equals("validity")) {
			//builder.setValidity(parseValidity(attrs.getValue("from"), attrs.getValue("to")));
		}
		cDataBuffer.reset();
	}

	private GenericTimeInterval parseValidity(String fromString, String toString) {
		DateFormat fmt = DateFormat.getDateInstance();
		Date from = null;
		if (!StringUtils.isBlank(fromString)) {	
			try {
				from = fmt.parse(fromString);
			} catch (ParseException e) {
				// TODO Utilizzare una ConfigurationException
				throw new RuntimeException(e);
			}
		}
		Date to = null;
		if (!StringUtils.isBlank(toString)) {
			try {
				to = fmt.parse(toString);
			} catch (ParseException e) {
				// TODO Utilizzare una ConfigurationException
				throw new RuntimeException(e);
			}
		}
		GenericTimeInterval validity = new GenericTimeInterval(from, to);
		return validity;
	}

	public void characters(char[] ch, int start, int length) throws SAXException {
		cDataBuffer.write(ch, start, length);
	}

	public void endElement(String namespaceURI, String localName, String qName) throws SAXException {
		if (qName.equals("place")) {
			builder.endPlace();
		} else if (qName.equals("code")) {
			builder.setCode(codeName, cDataBuffer.toString());
		} else if (qName.equals("description")) {
			builder.addDescription(cDataBuffer.toString());
		} else if (qName.equals("zipcode")) {
			builder.addZipCode(cDataBuffer.toString());
		} else if (qName.equals("places")) {
			
		} else {
			builder.setProperty(qName, cDataBuffer.toString());
		}
	}

}